#
#  Cocoa_PythonAppDelegate.py
#  Cocoa-Python
#
#  Created by Moises Aranas on 3/9/12.
#  Copyright __MyCompanyName__ 2012. All rights reserved.
#

# doge to btc: http://www.cryptocoincharts.info/v2/api/tradingPair/doge_btc
# btc to fiat: http://api.bitcoincharts.com/v1/weighted_prices.json

from Foundation import *
from AppKit import *
from objc import IBAction, IBOutlet
from PyObjCTools import AppHelper

import json
import time
import threading
import webbrowser
import urllib2

TIME_SLEEP = 300

class Cocoa_PythonAppDelegate(NSObject):
    main_menu = IBOutlet()
    about_view = IBOutlet()
    
    is_running = True
    
    status_item = None
    tray_icon = None
    
    dogevalue = 0.00;
    
    def applicationDidFinishLaunching_(self, sender):
        NSLog("Application did finish launching.")
        self.is_running = True
        threading.Thread(target=self.task_loop).start()
        self.status_item = NSStatusBar.systemStatusBar().statusItemWithLength_(-1)
        self.tray_icon = NSImage.alloc().initWithContentsOfFile_(NSBundle.mainBundle().pathForResource_ofType_("tray", "png"))
        self.status_item.setImage_(self.tray_icon)
        self.status_item.setHighlightMode_(True)
        self.status_item.setTarget_(self)
        self.status_item.setAction_("showMenu:")
        self.status_item.setTitle_("$%.8f" % self.dogevalue)
    
    def showMenu_(self, arg):
        self.status_item.popUpStatusItemMenu_(self.main_menu)

    def applicationShouldTerminate_(self, sender):
        NSLog("Application is terminating.")
        self.is_running = False
        return NSTerminateNow
    
    def task_loop(self):
        pool = NSAutoreleasePool.alloc().init()
        while self.is_running:
            innerpool = NSAutoreleasePool.alloc().init()
            doge_btc = float(json.loads(urllib2.urlopen("http://www.cryptocoincharts.info/v2/api/tradingPair/doge_btc").read())['price'])
            btc_usd = float(json.loads(urllib2.urlopen("http://www.cryptocoincharts.info/v2/api/tradingPair/btc_usd").read())['price'])
            self.dogevalue = doge_btc * btc_usd
            self.status_item.setTitle_("$%.8f" % self.dogevalue)
            time.sleep(TIME_SLEEP)
            del innerpool
        del pool

    @IBAction
    def quit_(self, arg):
        self.is_running = False
        AppHelper.callAfter(NSApp.terminate_, self)

    @IBAction
    def support_(self, arg):
        webbrowser.open("http://www.ganglionsoftware.com/contact.html")

    @IBAction
    def about_(self, arg):
        self.about_view.center()
        self.about_view.makeKeyAndOrderFront_(self)
        NSApp.activateIgnoringOtherApps_(True)
